/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of DS3231.xs. Do not edit this file, edit DS3231.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "DS3231.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <errno.h>
#include <fcntl.h>
#include <linux/i2c.h>
#include <linux/i2c-dev.h>
#include <sys/ioctl.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "rtc.h"
#include "bit.h"

/* top-level register */

#define RTC_REG_DT  0x00

/* sub-level registers */

#define RTC_SEC     0x00 // 0-59
#define RTC_MIN     0x01 // 0-59
#define RTC_HOUR    0x02 // 1-12 (12-hr clock), 0-23 (24-hr clock)
#define RTC_WDAY    0x03 // day of week (1-7)
#define RTC_MDAY    0x04 // day of month (1-31)
#define RTC_MONTH   0x05 // 1-12
#define RTC_YEAR    0x06 // 1-99

#define RTC_TEMP_MSB 0x11
#define RTC_TEMP_LSB 0x12

/* sub-level register bits */

// RTC_HOUR sub-level register bits

#define RTC_AM_PM   0x05
#define RTC_12_24   0x06

int getSeconds (int fd){
    return bcd2dec(getRegister(fd, RTC_SEC));
}

void setSeconds (int fd, int value){
    if (value < 0 || value > 59){
        croak("seconds parameter out of bounds. Must be between 0-59\n");
    }
    setRegister(fd, RTC_SEC, dec2bcd(value), "seconds");
}

int getMinutes (int fd){
    return bcd2dec(getRegister(fd, RTC_MIN));
}

void setMinutes (int fd, int value){
    if (value < 0 || value > 59){
        croak("minutes parameter out of bounds. Must be between 0-59\n");
    }
    setRegister(fd, RTC_MIN, dec2bcd(value), "minutes");
}

int getHour (int fd){
   
    int hour;

    if ((getRegisterBit(fd, RTC_HOUR, RTC_12_24)) == 0){
        // 24 hr clock
        hour = getRegister(fd, RTC_HOUR);
    }
    else {
        // 12 hr clock
        hour = getRegisterBits(fd, RTC_HOUR, 4, 0);
    }
    return bcd2dec(hour);
}

void setHour (int fd, int value){

    if ((getRegisterBit(fd, RTC_HOUR, RTC_12_24)) != 0){
        // 12 hour clock

        if (value > 12 || value < 1){
            char* error =
                "hour (%d) is out of bounds when in 12-hour clock " \
                "mode. Valid values are 1-12";

            croak(error);
        }
        setRegisterBits(fd, RTC_HOUR, 0, 5, value, "hour");
    }
    else {
        // 24 hour clock

        if (value > 23 || value < 0){
            char* error =
                "hour (%d) is out of bounds when in 24-hour clock " \
                "mode. Valid values are 0-23";

            croak(error);
        }
        value = dec2bcd(value);
        setRegister(fd, RTC_HOUR, value, "hour");
    }
}

const char* getDayOfWeek (int fd){
    int dow = bcd2dec(getRegister(fd, RTC_WDAY));
    return dayOfWeek[dow - 1];
}

void setDayOfWeek (int fd, int value){

    if (value > 7 || value < 1){
        croak("Day of week (%d) out of bounds. Must be 1-7 (Mon-Sun)\n", value);
    }

    setRegister(fd, RTC_WDAY, dec2bcd(value), "wday");
}

int getDayOfMonth (int fd){
    return(bcd2dec(getRegister(fd, RTC_MDAY)));
}

void setDayOfMonth (int fd, int value){

    if (value < 1 || value > 31){
        croak("Month day (%d) out of range. Must be between 1-31\n", value);
    }

    setRegister(fd, RTC_MDAY, dec2bcd(value), "dayofmonth");
}

int getMonth (int fd){

    int regVal = getRegister(fd, RTC_MONTH);
    int century = regVal & 0b10000000;
    return bcd2dec(regVal & 0b01111111);
}

void setMonth (int fd, int value){

    if (value < 1 || value > 12){
        croak("Month (%d) out of range. Must be between 1-12\n", value);
    }

    setRegisterBits(fd, RTC_MONTH, 0, 7, value, "month");
}

int getYear (int fd){
    return bcd2dec(getRegister(fd, RTC_YEAR)) + 2000;
}

void setYear (int fd, int value){

    if (value < 2000 || value > 2099){
        croak("Year (%d) out of range. Must be between 2000-2099\n", value);
    }

    int year = value - 2000;

    setRegister(fd, RTC_YEAR, dec2bcd(year), "year");
}

float getTemp (int fd){

    int msb = getRegister(fd, RTC_TEMP_MSB);
    int lsb = getRegister(fd, RTC_TEMP_LSB);

    float celcius = ((((short)msb << 8) | (short)lsb) >> 6) / 4.0;

    return celcius;
}

int getMeridien (int fd){

    if ((getRegisterBit(fd, RTC_HOUR, RTC_12_24)) == 0){
        croak(
            "AM/PM functionality not available when in 24-hour clock mode\n"
        );
    }
    return getRegisterBit(fd, RTC_HOUR, RTC_AM_PM);
}

void setMeridien (int fd, int value){

    if ((getRegisterBit(fd, RTC_HOUR, RTC_12_24)) == 0){
        croak(
            "AM/PM can not be set when in 24-hour clock mode\n"
        );
    }

    if (value == 1){
        enableRegisterBit(fd, RTC_HOUR, RTC_AM_PM);
    }
    else if (value == 0){
        disableRegisterBit(fd, RTC_HOUR, RTC_AM_PM);
    }
    else {
        croak(
            "AM/PM value (%d) out of bounds. Send 1 for enable, 0 for disable",
            value
        );
    }
}

int getMilitary (int fd){
    return getRegisterBit(fd, RTC_HOUR, RTC_12_24);
}

void setMilitary (int fd, int value){

    int militaryTime = getMilitary(fd);
    int hour = getHour(fd);

    if (militaryTime == value){
        // nothing to do
        return;
    }

    if (value == 1){
        // enable 12 hr clock
        if (hour == 0){
            // AM, at hour zero
            setHour(fd, 12);
            disableRegisterBit(fd, RTC_HOUR, RTC_AM_PM);
        }
        else if (getHour(fd) <= 12){
            // AM
            setHour(fd, hour);
            disableRegisterBit(fd, RTC_HOUR, RTC_AM_PM);
        }
        else {
            // PM
            setHour(fd, hour - 12);
            enableRegisterBit(fd, RTC_HOUR, RTC_AM_PM);
        }

        enableRegisterBit(fd, RTC_HOUR, RTC_12_24);
    }
    else {
        // enable 24 hr clock
        int meridien = getMeridien(fd);
        disableRegisterBit(fd, RTC_HOUR, RTC_12_24);

        if (meridien == 0){
            // AM
            if (hour == 12){
                setHour(fd, 0);
            }
            else {
                setHour(fd, hour);
            }
        }
        else {
            // PM
            if (hour < 12){
                setHour(fd, hour + 12);
            }
            else {
                setHour(fd, hour);
            }
        }
    }
}

int getFh (int rtcAddr){

    int fd;

    if ((fd = open("/dev/i2c-1", O_RDWR)) < 0) {
        close(fd);
        croak("Couldn't open the device: %s\n", strerror(errno));
	}

	if (ioctl(fd, I2C_SLAVE_FORCE, rtcAddr) < 0) {
        close(fd);
        croak(
            "Couldn't find device at addr %d: %s\n",
            rtcAddr,
            strerror(errno)
        );
	}

    _establishI2C(fd);

    return fd;
}

void disableRegisterBit (int fd, int reg, int bit){
    int data = bitOff(getRegister(fd, reg), bit);
    setRegister(fd, reg, data, "disabling bit");
}

void enableRegisterBit (int fd, int reg, int bit){
    int data = bitOn(getRegister(fd, reg), bit);
    setRegister(fd, reg, data, "enabling bit");
}

int getRegister (int fd, int reg){

    char buf[1];
    buf[0] = reg;

    if ((write(fd, buf, 1)) != 1){
        close(fd);
        croak(
            "Could not write register pointer %d: %s\n", 
            reg, 
            strerror(errno)
        );
    }

    if ((read(fd, buf, 1)) != 1){
        close(fd);
        croak("Could not read register %d: %s\n", reg, strerror(errno));
    }

    return buf[0];
}

int getRegisterBit (int fd, int reg, int bit){
    int regData = getRegister(fd, reg);
    return bitGet(regData, bit, bit);
}

int getRegisterBits (int fd, int reg, int msb, int lsb){
    return bitGet(getRegister(fd, reg), msb, lsb);
}

int setRegister(int fd, int reg, int value, char* name){
    /*
        always call dec2bcd(value) before sending
        in the value to this function
    */

    char buf[2] = {reg, value};

    if ((write(fd, buf, sizeof(buf))) != 2){
        close(fd);
        croak(
            "Could not write to the %s register: %s\n",
            name,
            strerror(errno)
        );
    }

    return 0;
}

int setRegisterBits(int fd, int reg, int lsb, int nbits, int value, char* name){
    /*
        never call dec2bcd(value) before sending
        in the value to this function
    */

    int data = getRegister(fd, reg);

    data = bitSet(data, lsb, nbits, value);

    char buf[2] = {reg, data};

    if ((write(fd, buf, sizeof(buf))) != 2){
        croak(
            "Could not write to the %s register: %s\n",
            name,
            strerror(errno)
        );
    }

    return 0;
}

int bcd2dec (int num){
  return (((num & 0xF0) >> 4) * 10) + (num & 0x0F);
}

int dec2bcd(int num){
   return((num/10) * 16 + (num%10));
}

void _establishI2C (int fd){

    int buf[1] = { 0x00 };

    if (write(fd, buf, 1) != 1){
        close(fd);
		croak("Error: Received no ACK bit, couldn't establish connection!");
    }
}

void _close (int fd){
    close(fd);
}

#line 406 "DS3231.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 550 "DS3231.c"

XS_EUPXS(XS_RPi__RTC__DS3231_setSeconds); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setSeconds)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setSeconds(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_setMinutes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setMinutes)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setMinutes(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_setMilitary); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setMilitary)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setMilitary(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_getMilitary); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getMilitary)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getMilitary(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_setMeridien); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setMeridien)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setMeridien(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_getMeridien); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getMeridien)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getMeridien(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_getHour); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getHour)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getHour(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_getSeconds); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getSeconds)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getSeconds(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_getMinutes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getMinutes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getMinutes(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_setHour); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setHour)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setHour(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_getDayOfWeek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getDayOfWeek)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	const char *	RETVAL;
	dXSTARG;

	RETVAL = getDayOfWeek(fd);
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_setDayOfWeek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setDayOfWeek)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setDayOfWeek(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_getDayOfMonth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getDayOfMonth)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getDayOfMonth(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_setDayOfMonth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setDayOfMonth)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setDayOfMonth(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_getMonth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getMonth)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getMonth(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_setMonth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setMonth)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setMonth(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_getYear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getYear)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getYear(fd);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_setYear); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setYear)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, value");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	value = (int)SvIV(ST(1))
;

	setYear(fd, value);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231_getTemp); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getTemp)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;
	float	RETVAL;
	dXSTARG;

	RETVAL = getTemp(fd);
	XSprePUSH;
	PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_getFh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getFh)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "rtcAddr");
    {
	int	rtcAddr = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getFh(rtcAddr);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_disableRegisterBit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_disableRegisterBit)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, reg, bit");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	bit = (int)SvIV(ST(2))
;
#line 490 "DS3231.xs"
        I32* temp;
#line 952 "DS3231.c"
#line 492 "DS3231.xs"
        temp = PL_markstack_ptr++;
        disableRegisterBit(fd, reg, bit);
        if (PL_markstack_ptr != temp) {
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY;
        }
        return;
#line 961 "DS3231.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_RPi__RTC__DS3231_enableRegisterBit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_enableRegisterBit)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, reg, bit");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	bit = (int)SvIV(ST(2))
;
#line 506 "DS3231.xs"
        I32* temp;
#line 985 "DS3231.c"
#line 508 "DS3231.xs"
        temp = PL_markstack_ptr++;
        enableRegisterBit(fd, reg, bit);
        if (PL_markstack_ptr != temp) {
          PL_markstack_ptr = temp;
          XSRETURN_EMPTY;
        }
        return;
#line 994 "DS3231.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_RPi__RTC__DS3231_getRegister); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getRegister)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "fd, reg");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getRegister(fd, reg);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_getRegisterBit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getRegisterBit)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, reg, bit");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	bit = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getRegisterBit(fd, reg, bit);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_getRegisterBits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_getRegisterBits)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "fd, reg, msb, lsb");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	msb = (int)SvIV(ST(2))
;
	int	lsb = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = getRegisterBits(fd, reg, msb, lsb);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_setRegister); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setRegister)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "fd, reg, value, name");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	value = (int)SvIV(ST(2))
;
	char*	name = (char *)SvPV_nolen(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = setRegister(fd, reg, value, name);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_setRegisterBits); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_setRegisterBits)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "fd, reg, lsb, nbits, value, name");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	reg = (int)SvIV(ST(1))
;
	int	lsb = (int)SvIV(ST(2))
;
	int	nbits = (int)SvIV(ST(3))
;
	int	value = (int)SvIV(ST(4))
;
	char*	name = (char *)SvPV_nolen(ST(5))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = setRegisterBits(fd, reg, lsb, nbits, value, name);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_bcd2dec); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_bcd2dec)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "num");
    {
	int	num = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = bcd2dec(num);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231_dec2bcd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231_dec2bcd)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "num");
    {
	int	num = (int)SvIV(ST(0))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = dec2bcd(num);
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_RPi__RTC__DS3231__establishI2C); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231__establishI2C)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;

	_establishI2C(fd);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_RPi__RTC__DS3231__close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_RPi__RTC__DS3231__close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "fd");
    {
	int	fd = (int)SvIV(ST(0))
;

	_close(fd);
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_RPi__RTC__DS3231); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_RPi__RTC__DS3231)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("RPi::RTC::DS3231::setSeconds", XS_RPi__RTC__DS3231_setSeconds);
        newXS_deffile("RPi::RTC::DS3231::setMinutes", XS_RPi__RTC__DS3231_setMinutes);
        newXS_deffile("RPi::RTC::DS3231::setMilitary", XS_RPi__RTC__DS3231_setMilitary);
        newXS_deffile("RPi::RTC::DS3231::getMilitary", XS_RPi__RTC__DS3231_getMilitary);
        newXS_deffile("RPi::RTC::DS3231::setMeridien", XS_RPi__RTC__DS3231_setMeridien);
        newXS_deffile("RPi::RTC::DS3231::getMeridien", XS_RPi__RTC__DS3231_getMeridien);
        newXS_deffile("RPi::RTC::DS3231::getHour", XS_RPi__RTC__DS3231_getHour);
        newXS_deffile("RPi::RTC::DS3231::getSeconds", XS_RPi__RTC__DS3231_getSeconds);
        newXS_deffile("RPi::RTC::DS3231::getMinutes", XS_RPi__RTC__DS3231_getMinutes);
        newXS_deffile("RPi::RTC::DS3231::setHour", XS_RPi__RTC__DS3231_setHour);
        newXS_deffile("RPi::RTC::DS3231::getDayOfWeek", XS_RPi__RTC__DS3231_getDayOfWeek);
        newXS_deffile("RPi::RTC::DS3231::setDayOfWeek", XS_RPi__RTC__DS3231_setDayOfWeek);
        newXS_deffile("RPi::RTC::DS3231::getDayOfMonth", XS_RPi__RTC__DS3231_getDayOfMonth);
        newXS_deffile("RPi::RTC::DS3231::setDayOfMonth", XS_RPi__RTC__DS3231_setDayOfMonth);
        newXS_deffile("RPi::RTC::DS3231::getMonth", XS_RPi__RTC__DS3231_getMonth);
        newXS_deffile("RPi::RTC::DS3231::setMonth", XS_RPi__RTC__DS3231_setMonth);
        newXS_deffile("RPi::RTC::DS3231::getYear", XS_RPi__RTC__DS3231_getYear);
        newXS_deffile("RPi::RTC::DS3231::setYear", XS_RPi__RTC__DS3231_setYear);
        newXS_deffile("RPi::RTC::DS3231::getTemp", XS_RPi__RTC__DS3231_getTemp);
        newXS_deffile("RPi::RTC::DS3231::getFh", XS_RPi__RTC__DS3231_getFh);
        newXS_deffile("RPi::RTC::DS3231::disableRegisterBit", XS_RPi__RTC__DS3231_disableRegisterBit);
        newXS_deffile("RPi::RTC::DS3231::enableRegisterBit", XS_RPi__RTC__DS3231_enableRegisterBit);
        newXS_deffile("RPi::RTC::DS3231::getRegister", XS_RPi__RTC__DS3231_getRegister);
        newXS_deffile("RPi::RTC::DS3231::getRegisterBit", XS_RPi__RTC__DS3231_getRegisterBit);
        newXS_deffile("RPi::RTC::DS3231::getRegisterBits", XS_RPi__RTC__DS3231_getRegisterBits);
        newXS_deffile("RPi::RTC::DS3231::setRegister", XS_RPi__RTC__DS3231_setRegister);
        newXS_deffile("RPi::RTC::DS3231::setRegisterBits", XS_RPi__RTC__DS3231_setRegisterBits);
        newXS_deffile("RPi::RTC::DS3231::bcd2dec", XS_RPi__RTC__DS3231_bcd2dec);
        newXS_deffile("RPi::RTC::DS3231::dec2bcd", XS_RPi__RTC__DS3231_dec2bcd);
        newXS_deffile("RPi::RTC::DS3231::_establishI2C", XS_RPi__RTC__DS3231__establishI2C);
        newXS_deffile("RPi::RTC::DS3231::_close", XS_RPi__RTC__DS3231__close);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
